unit dynamat;
interface
type tVector=array[0..65519] of byte;
     ptVector=^tVector;
     tMatrix=array[0..16379] of ptVector;
     ptMatrix=^tMatrix;
     ptInteger=^integer;
     ptReal=^real;
     ptChar=^char;
     ptWord=^word;
     ptByte=^byte;
     ptLongint=^longint;
     ptBoolean=^boolean;
     ptString=^string;
     typeAndName=string[25];

     vector=object
       _: ptVector; nature: char; name: string[24];
       lastCol,size: word;
       procedure assign(tn: typeAndName);
       procedure rewrite(col: word);
       procedure fillChar(filler: byte);
       procedure close;
       function i(col: word): ptInteger;
       function l(col: word): ptLongint;
       function c(col: word): ptChar;
       function t(col: word): ptBoolean;
       function r(col: word): ptReal;
       function w(col: word): ptWord;
       function b(col: word): ptByte;
       function ii(col: word): ptInteger;
       function ll(col: word): ptLongint;
       function cc(col: word): ptChar;
       function tt(col: word): ptBoolean;
       function rr(col: word): ptReal;
       function ww(col: word): ptWord;
       function bb(col: word): ptByte;
     end;
     matrix=object
       lastRow,lastCol,size: word; nature: char; name: string[24];
       _: ptMatrix;
       procedure assign(tn: typeAndName);
       procedure rewrite(row,col: word);
       procedure close;
       procedure fillChar(filler: byte);
       function i(row,col: word) : ptinteger;
       function c(row,col: word): ptchar;
       function r(row,col: word): ptreal;
       function t(row,col: word): ptboolean;
       function l(row,col: word): ptLongint;
       function w(row,col: word): ptWord;
       function b(row,col: word): ptByte;
       function s(row: word): ptString;
       function p(row: word): pointer;
       function pp(row: word): pointer;
       function ii(row,col: word) : ptinteger;
       function cc(row,col: word): ptchar;
       function rr(row,col: word): ptreal;
       function tt(row,col: word): ptboolean;
       function ll(row,col: word): ptLongint;
       function ww(row,col: word): ptWord;
       function bb(row,col: word): ptByte;
       function ss(row: word): ptString;
     end;
     vvector=object
       _: ptVector; nature: char; name: string[24];
       lastCol,size: word;
       procedure assign(tn: typeAndName);
       procedure rewrite(col: word);
       procedure close;
       function i(col: word): ptInteger;
       function l(col: word): ptLongint;
       function c(col: word): ptChar;
       function t(col: word): ptBoolean;
       function r(col: word): ptReal;
       function w(col: word): ptWord;
       function b(col: word): ptByte;
     end;
     mmatrix=object
       lastRow,lastCol,size: word; nature: char; name: string[24];
       _: ptMatrix;
       procedure assign(tn: typeAndName);
       procedure rewrite(row,col: word);
       procedure close;
       function i(row,col: word) : ptinteger;
       function c(row,col: word): ptchar;
       function r(row,col: word): ptreal;
       function t(row,col: word): ptboolean;
       function l(row,col: word): ptLongint;
       function w(row,col: word): ptWord;
       function b(row,col: word): ptByte;
       function s(row: word): ptString;
       function p(row: word): pointer;
     end;


implementation
       const max1= 65519;
             max2= 32759;
             max4= 16379;
             max6= 10919;
       type intVec= array[0..max2] of integer;
            wordVec=array[0..max2] of word;
            boolVec=array[0..max1] of boolean;
            charVec=array[0..max1] of char;
            byteVec=array[0..max1] of byte;
            longVec=array[0..max4] of longint;
            realVec=array[0..max6] of real;
       procedure adjustVectorSize(var col: word; nature: char; name: string);
       var max: word;
       begin case nature of
               'B','C','T': max:=max1;
               'I','W': max:=max2;
               'L': max:=max4;
               'R': max:=max6
             end;
             if col>max then
             begin writeln;
                   writeln('WARNING: vector '+name+': size adjusted to ',max,
                           ' down from ',col);
                   col:=max
             end

       end;
       procedure adjustMatrixSize(var col: word; nature: char; name: string);
       var max: word;
       begin case nature of
               'B','C','T': max:=max1;
               'I','W': max:=max2;
               'L','S','P': max:=max4;
               'R': max:=max6
             end;
             if col>max then
             begin writeln;
                   writeln('WARNING: matrix '+name+': size adjusted to ',max,
                           ' down from ',col);
                   col:=max
             end

       end;

       procedure vectorError(var v: vector; ch: char; row: word);
       begin writeln;
             writeln('Error addressing vector: '+v.name+'.'+ch+ch+'(',row,')^');
             if v.nature<>ch then writeln('Type mismatch');
             if row>v.lastCol then writeln('Upper boundary  is ',v.lastCol);
             v.close;
             halt
       end;
       procedure matrixError1(var m: matrix; ch: char; row: word);
       begin writeln;
             writeln('Error addressing matrix: '+m.name+'.'+ch+ch+'(',row,')^');
             if m.nature<>ch
             then writeln('Type mismatch');
             if row>m.lastRow
             then writeln('Upper boundaries are ',m.lastRow,',',m.lastCol);
             m.close;
             halt
       end;
       procedure matrixError2(var m: matrix; ch: char; row,col: word);
       begin writeln;
             writeln('Error addressing matrix: '+m.name+'.'+ch+ch+'(',
                      row,',',col,')^');
             if m.nature<>ch
             then writeln('Type mismatch');
             if (row>m.lastRow) or (col>m.lastCol)
             then writeln('Upper boundaries are ',m.lastRow,',',m.lastCol);
             m.close;
             halt
       end;

       procedure vector.assign(tn: typeAndName);
       begin system.FillChar(self,sizeOf(self),0);
             nature:=upcase(tn[1]);
             name:=copy(tn,2,length(tn)-1)
       end;
       procedure vector.fillChar(filler: byte);
       begin system.fillChar(_^,size,filler)
       end;

       procedure vector.rewrite(col: word);
       begin adjustVectorSize(col,nature,name);
             lastcol:=col;
             inc(col);
         case nature of
            'B','C','T': size:=col;
            'I','W': size:=col*2;
                'L': size:=col*4;
                'R': size:=col*6;
            else writeln('Error rewriting vector '+name+': bad type '+nature);
                 halt
         end;
         GetMem(_,size); system.FillChar(_^,size,0);
       end;
       procedure vector.close;
       begin
         FreeMem(_,size);
         system.FillChar(self,sizeOf(self),0);
       end;
       function vector. i(col: word): ptInteger;
       begin i:=@intVec(_^)[col]
       end;
       function vector. l(col: word): ptLongint;
       begin l:=@longVec(_^)[col]
       end;
       function vector. c(col: word): ptChar;
       begin c:=@charVec(_^)[col]
       end;
       function vector. t(col: word): ptBoolean;
       begin t:=@boolVec(_^)[col]
       end;
       function vector. r(col: word): ptReal;
       begin r:=@realVec(_^)[col]
       end;
       function vector. b(col: word): ptByte;
       begin b:=@byteVec(_^)[col]
       end;
       function vector. w(col: word): ptWord;
       begin w:=@wordVec(_^)[col]
       end;
       function vector. ii(col: word): ptInteger;
       begin if(nature='I') and (col<=lastcol) then ii:=@intVec(_^)[col]
             else vectorerror(self,'I',col)
       end;
       function vector. ll(col: word): ptLongint;
       begin if(nature='L') and (col<=lastcol) then ll:=@longVec(_^)[col]
             else vectorerror(self,'L',col)
       end;
       function vector. cc(col: word): ptChar;
       begin if(nature='C') and (col<=lastcol) then cc:=@charVec(_^)[col]
             else vectorerror(self,'C',col)
       end;
       function vector. tt(col: word): ptBoolean;
       begin if(nature='T') and (col<=lastcol) then tt:=@boolVec(_^)[col]
             else vectorerror(self,'T',col)
       end;
       function vector. rr(col: word): ptReal;
       begin if(nature='R') and (col<=lastcol) then rr:=@realVec(_^)[col]
             else vectorerror(self,'R',col)
       end;
       function vector. bb(col: word): ptByte;
       begin if(nature='B') and (col<=lastcol) then bb:=@byteVec(_^)[col]
             else vectorerror(self,'B',col)
       end;
       function vector. ww(col: word): ptWord;
       begin if(nature='W') and (col<=lastcol) then ww:=@wordVec(_^)[col]
             else vectorerror(self,'W',col)
       end;

       procedure matrix.assign(tn: typeAndName);
       begin system.FillChar(self,sizeOf(self),0); nature:=upcase(tn[1]);
             name:=copy(tn,2,length(tn)-1);
       end;
       procedure matrix.fillChar(filler: byte);
       var row: word;
       begin  for row:=0 to lastRow do
              system.FillChar(_^[row]^,size,filler);
       end;
       procedure matrix.rewrite(row,col: word);
       begin
         if row>max4 then row:=max4;
         lastRow:=row;
         adjustMatrixSize(col,nature,name);
         lastCol:=col; inc(col);
         case nature of
        'B','C','T': size:=col;
             'I','W': size:=col*2;
                 'L': size:=col*4;
                 'R': size:=col*6;
              'P','S': size:=col+1;
            else writeln('Error rewriting matrix '+name+': bad type '+nature);
                 halt
         end;
         GetMem(_,(row+1)*sizeOf(pointer));
         for row:=0 to lastRow do
         begin
               GetMem(_^[row],size);
               system.FillChar(_^[row]^,size,0);
         end
       end;
       procedure matrix.close;
       var y: word;
       begin inc(lastCol);
         for y:=lastRow downto 0 do FreeMem(_^[y],size);
         FreeMem(_,(lastRow+1)*sizeOf(pointer));
         system.fillChar(self,sizeOf(self),0)
       end;

       function matrix.s(row: word): ptString;
       begin s:=ptString(_^[row])
       end;

       function matrix.p(row: word): pointer;
       begin p:=_^[row]
       end;

       function matrix.i(row,col: word) : ptinteger;
       begin i:=@intVec(_^[row]^)[col]
       end;

       function matrix.l(row,col: word) : ptLongint;
       begin l:=@longVec(_^[row]^)[col]
       end;
       function matrix.c(row,col: word): ptchar;
       begin c:=@charVec(_^[row]^)[col]
       end;
       function matrix.r(row,col: word): ptreal;
       begin r:=@realVec(_^[row]^)[col]
       end;
       function matrix.t(row,col: word): ptboolean;
       begin t:=@boolVec(_^[row]^)[col]
       end;
       function matrix.b(row,col: word): ptByte;
       begin b:=@byteVec(_^[row]^)[col]
       end;
       function matrix.w(row,col: word): ptWord;
       begin w:=@wordVec(_^[row]^)[col]
       end;
       function matrix.ww(row,col: word): ptWord;
       begin if (nature='W') and (row<=lastRow) and (col<=lastCol)
             then ww:=@wordVec(_^[row]^)[col]
             else matrixError2(self,'W',row,col);
       end;
       function matrix.ii(row,col: word): ptInteger;
       begin if (nature='I') and (row<=lastRow) and (col<=lastCol)
             then ii:=@intVec(_^[row]^)[col]
             else matrixError2(self,'I',row,col);
       end;
       function matrix.rr(row,col: word): ptReal;
       begin if (nature='R') and (row<=lastRow) and (col<=lastCol)
             then rr:=@realVec(_^[row]^)[col]
             else matrixError2(self,'R',row,col);
       end;
       function matrix.bb(row,col: word): ptByte;
       begin if (nature='B') and (row<=lastRow) and (col<=lastCol)
             then bb:=@byteVec(_^[row]^)[col]
             else matrixError2(self,'B',row,col);
       end;
       function matrix.cc(row,col: word): ptChar;
       begin if (nature='C') and (row<=lastRow) and (col<=lastCol)
             then cc:=@charVec(_^[row]^)[col]
             else matrixError2(self,'C',row,col);
       end;
       function matrix.tt(row,col: word): ptBoolean;
       begin if (nature='T') and (row<=lastRow) and (col<=lastCol)
             then tt:=@boolVec(_^[row]^)[col]
             else matrixError2(self,'T',row,col);
       end;
       function matrix.ll(row,col: word): ptLongint;
       begin if (nature='L') and (row<=lastRow) and (col<=lastCol)
             then ll:=@longVec(_^[row]^)[col]
             else matrixError2(self,'L',row,col);
       end;
       function matrix.ss(row: word): ptString;
       begin if (nature='S') and (row<=lastRow)
             then ss:=ptString(_^[row])
             else matrixError1(self,'S',row);
       end;
       function matrix.pp(row: word): pointer;
       begin if (nature='P') and (row<=lastRow)
             then pp:=_^[row]
             else matrixError1(self,'P',row);
       end;
       procedure vvectorError(var v: vvector; ch: char; row: word);
       begin writeln;
             writeln('Error addresing vvector with '+v.name+'.'+ch+'(',row,')^');
             if v.nature<>ch then writeln('Type mismatch');
             if row>v.lastCol then writeln('Upper boundary  is ',v.lastCol);
             v.close;
             halt
       end;
       procedure mmatrixError1(var m: mmatrix; ch: char; row: word);
       begin writeln;
             writeln('Error addresing mmatrix with '+m.name+'.'+ch+'(',row,')^');
             if m.nature<>ch
             then writeln('Type mismatch');
             if row>m.lastRow
             then writeln('Upper boundaries are ',m.lastRow,',',m.lastCol);
             m.close;
             halt
       end;
       procedure mmatrixError2(var m: mmatrix; ch: char; row,col: word);
       begin writeln;
             writeln('Error addresing mmatrix with '+m.name+'.'+ch+'(',
                      row,',',col,')^');
             if m.nature<>ch
             then writeln('Type mismatch');
             if (row>m.lastRow) or (col>m.lastCol)
             then writeln('Upper boundaries are ',m.lastRow,',',m.lastCol);
             m.close;
             halt
       end;

       procedure vvector.assign(tn: typeAndName);
       begin FillChar(self,sizeOf(self),0); nature:=upcase(tn[1]);
             name:=copy(tn,2,length(tn)-1)
       end;
       procedure vvector.rewrite(col: word);
       begin
         adjustVectorSize(col,nature,name);
         lastCol:=col; inc(col);
         case nature of
            'B','C','T': size:=col;
            'I','W': size:=col*2;
                'L': size:=col*4;
                'R': size:=col*6;
            else writeln('Error rewriting vvector '+name+': bad type '+nature);
                 halt
         end;
         GetMem(_,size); FillChar(_^,size,0);
       end;
       procedure vvector.close;
       begin
         FreeMem(_,size);
         FillChar(self,sizeOf(self),0);
       end;
       function vvector. i(col: word): ptInteger;
       begin if(nature='I') and (col<=lastCol) then i:=@intVec(_^)[col]
             else vvectorError(self,'I',col)
       end;
       function vvector. l(col: word): ptLongint;
       begin if(nature='L') and (col<=lastCol) then l:=@longVec(_^)[col]
             else vvectorError(self,'L',col)
       end;
       function vvector. c(col: word): ptChar;
       begin if(nature='C') and (col<=lastcol) then c:=@charVec(_^)[col]
             else vvectorError(self,'C',col)
       end;
       function vvector. t(col: word): ptBoolean;
       begin if(nature='T') and (col<=lastcol) then t:=@boolVec(_^)[col]
             else vvectorError(self,'T',col)
       end;
       function vvector. r(col: word): ptReal;
       begin if(nature='R') and (col<=lastcol) then r:=@realVec(_^)[col]
             else vvectorError(self,'R',col)
       end;
       function vvector. b(col: word): ptByte;
       begin if(nature='B') and (col<=lastcol) then b:=@byteVec(_^)[col]
             else vvectorError(self,'B',col)
       end;
       function vvector. w(col: word): ptWord;
       begin if(nature='W') and (col<=lastcol) then w:=@wordVec(_^)[col]
             else vvectorError(self,'W',col)
       end;

       procedure mmatrix.assign(tn: typeAndName);
       begin FillChar(self,sizeOf(self),0); nature:=upcase(tn[1]);
             name:=copy(tn,2,length(tn)-1);
       end;

       procedure mmatrix.rewrite(row,col: word);
       begin
         if row>max4 then row:=max4;
         lastRow:=row;
         adjustMatrixSize(col,nature,name);
         lastCol:=col; inc(col);
         case nature of
        'B','C','T': size:=col;
            'I','W': size:=col*2;
            'P','L': size:=col*4;
                'R': size:=col*6;
                'S': size:=col+1;
            else writeln('Error rewriting mmatrix '+name+': bad type '+nature);
                 halt
         end;
         GetMem(_,(row+1)*sizeOf(pointer));
         for row:=0 to lastRow do
         begin GetMem(_^[row],size);
               FillChar(_^[row]^,size,0);
         end
       end;
       procedure mmatrix.close;
       var y: word;
       begin inc(lastCol);
         for y:=lastRow downto 0 do FreeMem(_^[y],size);
         FreeMem(_,(lastRow+1)*sizeOf(pointer));
         FillChar(self,sizeOf(self),0)
       end;

       function mmatrix.w(row,col: word): ptWord;
       begin if (nature='W') and (row<=lastRow) and (col<=lastCol)
             then w:=@wordVec(_^[row]^)[col]
             else mmatrixError2(self,'W',row,col);
       end;
       function mmatrix.i(row,col: word): ptInteger;
       begin if (nature='I') and (row<=lastRow) and (col<=lastCol)
             then i:=@intVec(_^[row]^)[col]
             else mmatrixError2(self,'I',row,col);
       end;
       function mmatrix.r(row,col: word): ptReal;
       begin if (nature='R') and (row<=lastRow) and (col<=lastCol)
             then r:=@realVec(_^[row]^)[col]
             else mmatrixError2(self,'R',row,col);
       end;
       function mmatrix.b(row,col: word): ptByte;
       begin if (nature='B') and (row<=lastRow) and (col<=lastCol)
             then b:=@byteVec(_^[row]^)[col]
             else mmatrixError2(self,'B',row,col);
       end;
       function mmatrix.c(row,col: word): ptChar;
       begin if (nature='C') and (row<=lastRow) and (col<=lastCol)
             then c:=@charVec(_^[row]^)[col]
             else mmatrixError2(self,'C',row,col);
       end;
       function mmatrix.t(row,col: word): ptBoolean;
       begin if (nature='T') and (row<=lastRow) and (col<=lastCol)
             then t:=@boolVec(_^[row]^)[col]
             else mmatrixError2(self,'T',row,col);
       end;
       function mmatrix.l(row,col: word): ptLongint;
       begin if (nature='L') and (row<=lastRow) and (col<=lastCol)
             then l:=@longVec(_^[row]^)[col]
             else mmatrixError2(self,'L',row,col);
       end;
       function mmatrix.s(row: word): ptString;
       begin if (nature='S') and (row<=lastRow)
             then s:=ptString(_^[row])
             else mmatrixError1(self,'S',row);
       end;
       function mmatrix.p(row: word): pointer;
       begin if (nature='P') and (row<=lastRow)
             then p:=_^[row]
             else mmatrixError1(self,'P',row);
       end;

end.

