uses lg3,dynamat,gauge,crt;
function fileName(fn: string): string;
begin if pos('.',fn)=0 then fn:=fn+'.' else
      while (fn<>'') and (fn[length(fn)]<>'.') do dec(fn[0]);
      fileName:=fn
end;

function fileExists(fn: string): boolean;
var f: file;
begin assign(f,fn); {$I-} reset(f); {$I+}
      if IOResult=0 then begin fileExists:=true; close(f) end
      else fileExists:=false
end;

var args: record
          fn,fnCorpus,fnAlpha,fnDic,fnCode,fnLst: string;
          line1,line2: string;
          alpha: array[char] of char
    end;

procedure getArgs;
begin with args do
begin  fnCorpus:=''; fnAlpha:='';
       case paramCount of
       1: fnCorpus:=paramStr(1);
       2: begin fnCorpus:=paramStr(1); fnAlpha:=paramStr(2)
          end;
        else begin
          write('  Read corpus from file: '); readln(fnCorpus);
          write('Read alphabet from file: '); readln(fnAlpha);
         end;
      end;
      if not fileExists(fnCorpus) or (fnCorpus='') then
      begin writeln(fnCorpus,' not found'); Halt
      end;
      fn:=fileName(fnCorpus);
      fnDic:=fn+'DIC';
      fnLst:=fn+'LST';
      fnCode:=fn+'COD';
end end;

procedure makeAlpha;
var f: text; ch: char; i: integer;
begin fillChar(args.alpha,sizeOf(args.alpha),0);
      args.line1:='abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ';
      args.line2:='ABCDEFGHIJKLMNOPQRSTUVWXYZ';
      if (args.fnAlpha<>'') and fileExists(args.fnAlpha) then
      begin assign(f,args.fnAlpha); reset(f);
            readln(f,args.line1); readln(f,args.line2)
      end;
      with args do for i:=1 to length(line1) do
      begin ch:=line1[i];
            if (i<=length(line2)) and (line2[i]<>' ')
            then alpha[ch]:=line2[i]
            else alpha[ch]:=ch
      end
end;

procedure makeDic(var dic: dictionary);
var ch: char; entry: string; f: text;
    gauge: aGauge;
    n: longint;
begin dic.Assign(args.fnCorpus); dic.Rewrite(1000);
      gauge.assign(args.fnCorpus);
      gauge.rewrite(WhereY,WhereX,'Building dictionary...');
      assign(f,args.fnCorpus); reset(f); entry:='';
      while not eof(f) do
      begin read(f,ch); ch:=args.alpha[ch];
            gauge.add(1);
            if (ch<>#0) and (ch<>'.') then entry:=entry+ch
            else if entry<>'' then
            begin dic.Write(entry); entry:='';
            end;
      end;
      if entry<>'' then dic.Write(entry);
      close(f);
      writeln; writeln;
      gauge.close;

end;

procedure writeDic(var dic: dictionary);
var f: text; entry: string;
begin assign(f,args.fnDic); rewrite(f);
      writeln(f,dic.name);
      writeln(f,args.line1);
      writeln(f,args.line2);
      dic.Seek(1);
      while not dic.Eof do
      begin dic.Read(entry);
            writeln(f,dic.Frequency:6,' ',entry);
      end;
      close(f)
end;

procedure countWords(var n: word; var maxLength: byte);
var f: text; fq: longint; ch: char; buffer: string; i:byte;
begin assign(f,args.fnDic); reset(f);
      for i:=1 to 3 do readln(f); (* header *)
      n:=0; maxLength:=0;
      while not eof(f) do
      begin inc(n); readln(f,fq,ch,buffer);
            if length(buffer)>maxLength
            then maxLength:=length(buffer)
      end;
      close(f)
end;

procedure sortFq(var mat: matrix; var fq: vector);
var  i,j,k,m,n: integer; swap,yes: boolean;
     tmp: string; tmpFq: longint;
     function doSwap(i,j: integer): boolean;
     begin if fq.l(i)^>fq.l(j)^ then doswap:=false else
           if fq.l(i)^<fq.l(j)^ then doswap:=true else
           if mat.s(i)^>mat.s(j)^ then doswap:=true
           else doswap:=false
     end;
begin  m:=1; n:=mat.lastRow;
       while m<=n do m:=m+m; m:=(m-1) DIV 2;
       while m>0 do
       begin  for j:=1 TO n-m do
	 begin  i:=j; k:=i+m; swap:=true;
	   repeat if doswap(i,k) then
	     begin  tmpFq:=fq.l(i)^;
	        fq.l(i)^:=fq.l(k)^; fq.l(k)^:=tmpFq;
                tmp:=mat.s(i)^;
	        mat.s(i)^:=mat.s(k)^; mat.s(k)^:=tmp;
 	        i:=i-m; k:=i+m;
                  swap:=i>0;
           end else swap:=false
         until not swap
       end;
       m:=m DIV 2
     end;
end;

procedure readAndWriteDic(var m: matrix);
var f,f2: text; i,n: word; longest: byte; ch: char; fq: vector;
    buffer: string;
    gauge: aGauge;
begin
      countWords(n,longest);
      gauge.JobSize:=n;
      gauge.rewrite(wherey,wherex,'Writing wordlist...');
      m.assign('s'); m.rewrite(n,longest);
      fq.assign('l'); fq.rewrite(n);
      assign(f,args.fnDic); reset(f);
      assign(f2,args.fnLst); rewrite(f2);
      readln(f,buffer); writeln(f2,buffer); { corpus fn }
      writeln(f2,args.fnDic); { input dictionary fn }
      for i:=1 to 2 do
      begin readln(f,buffer); writeln(f2,buffer); {alphabet}
      end;
      i:=0;
      while not eof(f) do
      begin inc(i); readln(f,fq.l(i)^,ch, m.s(i)^)
      end;
      close(f);
      sortFq(m,fq);
      for i:=1 to n do
      begin writeln(f2,fq.l(i)^:6,' ',m.s(i)^); gauge.add(1);
      end;
      close(f2);
      writeln; writeln; gauge.close;
end;

procedure encode(var d: dictionary);
const bufSize=4096;
var corpus: text; code: file;
    entry: string; ch: char; k: longint; w,lgth: word;
    gauge: aGauge;
    known,unknown: longint;
    buffer: array[1..bufSize] of word;
    header: array[1..bufSize*2] of char absolute buffer;
    bufPos,bufOut: word;

    procedure put(st: string; var w: word);
    var lgth: word;
    begin lgth:=length(st)+1;
          move(st,header[w],lgth);
          inc(w,lgth);
    end;

begin assign(code,args.fnCode); rewrite(code,2);
      gauge.assign(args.fnCorpus);
      gauge.rewrite(WhereY,WhereX,'Encoding corpus...');
      w:=1;

      put(args.fnCorpus,w);
      put(args.fnDic,w);
      put(args.fnLst,w);
      put(args.line1,w);
      put(args.line2,w);
      if odd(w) then bufPos:=(w+1) div 2 else bufPos:=w div 2;
      assign(corpus,args.fnCorpus); reset(corpus);
      d.QuickSearch;
      entry:=''; known:=0; unknown:=0;
      while not eof(corpus) do
      begin read(corpus,ch); ch:=args.alpha[ch]; gauge.add(1);
            if  (ch<>#0) then entry:=entry+ch
            else if entry<>'' then
            begin d.Find(entry,k);
                  if k<0 then begin w:=0; inc(unknown) end
                  else begin w:=k; inc(known) end;
                  inc(BufPos); buffer[bufPos]:=w;
                  if BufPos=bufSize then
                  begin blockwrite(code,buffer,bufPos,bufOut);
                        bufPos:=0
                  end;
                  entry:='';
            end;
      end;
      if entry<>'' then
      begin d.QuickFind(entry,k);
            if k<0 then w:=0 else w:=k;
            inc(bufPos); buffer[bufPos]:=w;
      end;
      if bufPos>0 then blockWrite(code,buffer,bufPos,bufOut);
      close(corpus); close(code);
      writeln; writeln; gauge.close;
end;

procedure advise;
begin writeln; writeln;
      writeln('The coded corpus is in file '+args.fnCode);
      writeln('You may now produce co-occurrence frequency tables.');
      writeln('Type:');
      writeln('FQ ',args.fn);
      writeln;
      writeln('and answer the prompts.');
      writeln;
end;

var dic: dictionary;
    m: matrix;
begin writeln; writeln;
      getArgs;
      makeAlpha;
      makeDic(dic);
      writeDic(dic);
      encode(dic);
      dic.Erase;
      readAndWriteDic(m);
      m.close;
      advise
end.