uses dynamat,lg3,gauge,crt;
function fileName(fn: string): string;
begin if pos('.',fn)=0 then fn:=fn+'.' else
      while (fn<>'') and (fn[length(fn)]<>'.') do dec(fn[0]);
      fileName:=fn
end;

var args: record fnDic,fnFqDic,fnCorpus,fnPlain,fnFq: string;
          maxWords,allWords: word;
          left,right: integer;
          fqDic: dictionary;
          corpus: longarray;
          wordsToSkip: word;
          sortedFq: boolean
    end;

procedure getArgs;
var ch: char;
begin with args do
   begin
      if paramCount=1 then fnCorpus:=paramStr(1)
      else
      begin write('Read coded corpus from file: ');
           readln(fnCorpus)
      end;
      fnCorpus:=fileName(fnCorpus)+'COD';
      write('Write frequencies to files (no extension!): ');
      readln(fnFq);
      fnFq:=fileName(fnFq);
      write('Sort frequencies? (y/n): ');
      repeat ch:=upcase(readKey) until (ch='Y') or (ch='N');
      sortedFq:=ch='Y';
      writeln(ch);
      write('Count only the N most frequent words. N= ');
      readln(maxWords);
      if Maxwords<1 then maxWords:=65519;
      write('Lefmost environment: ');
      readln(left);
      write('Rightmost environment: ');
      readln(right);
      writeln; writeln;
   end
end;


procedure readFqDic(var d: dictionary);
var f: text; i,n: word; fq: longint; ch: char; entry: string;
    gauge: aGauge;
begin
      gauge.JobSize:=args.maxWords;
      gauge.rewrite(wherey,wherex,'Reading '+args.fnFqDic+'...');
      d.assign(''); d.rewrite(args.maxWords);
      assign(f,args.fnFqDic); reset(f);
      for i:=1 to 4 do
      begin readln(f,entry); { skip header }
      end;
      i:=0;
      while not eof(f) and (i<args.maxWords) do
      begin readln(f,fq,ch,entry);
            d.add(entry,fq);
            gauge.add(1);
            inc(i);
      end;
      close(f); gauge.close;
end;

procedure readDic(var d: dictionary);
var f: text; fq: longint; ch: char; entry: string; i: byte;
    gauge: aGauge;
begin
      d.assign(''); d.rewrite(1000);
      assign(f,args.fnDic); reset(f);
      gauge.assign(args.fnDic);
      gauge.rewrite(wherey,wherex,'Reading '+args.fnDic+'...');
      for i:=1 to 3 do
      begin
          readln(f,entry); {skip header}
          gauge.add(length(entry)+2)
      end;

      while not eof(f) do
      begin readln(f,fq,ch,entry);
            d.add(entry,fq);
            gauge.add(length(entry)+9)
      end;
      close(f); gauge.close;
      args.allWords:=d.Last;
      if args.maxWords>args.allWords then args.maxWords:=args.allWords
end;

procedure buildMatcher(fqDic,dic: dictionary; var corr: vector);
var entry: string; i: longint; posInDic,posInFqDic: word;
begin corr.assign('wCorr'); corr.rewrite(dic.Last);
      fqDic.Seek(1); posInFqDic:=1;
      while not fqDic.eof do
      begin fqDic.read(entry);
            dic.Find(entry,i);
            posInDic:=i;
            corr.w(posInDic)^:=posInFqDic;
            inc(posInFqDic)
      end;
end;

procedure getFn;
var code: file;
    procedure getString(var st: string; var n: word);
    var inBuf,lgth: word;
    begin
      blockread(code,st[0],1,inBuf); inc(n);
      lgth:=ord(st[0]);
      blockread(code,st[1],lgth,inBuf); inc(n,lgth);
    end;
var junk: string;
begin
      assign(code,args.fnCorpus); reset(code,1);
      with args do
      begin
       wordsToSkip:=0;
       getString(fnPlain,wordsToSkip);
       getString(fnDic,wordsToSkip);
       getString(fnFqDic,wordsToSkip);
       getString(junk,wordsToSkip); {skip alphabet}
       getString(junk,wordsToSkip);
       if odd(wordsToSkip)
       then wordsToSkip:=(wordsToSkip+1) div 2
       else wordsToSkip:=(wordsToSkip) div 2
      end;
end;

procedure readCorpus(d: dictionary; corr: vector; var corpus: longarray);
const bufSize=2048;
var f: file; code: word;
    buffer: array[1..bufSize] of word;
    i,bufIn,bufEnd: integer;
    n: longint;
    gauge: aGauge;
begin assign(f,args.fnCorpus); reset(f,2);
      gauge.assign(args.fnCorpus);
      gauge.rewrite(whereY,whereX,'Reading coded corpus...');
      blockRead(f,buffer,args.wordsToSkip,bufIn);
      gauge.add(args.wordsToSkip*2);
      fillChar(buffer,sizeOf(buffer),0);
      corpus.assign('corpus'); corpus.rewrite(fileSize(f),sizeOf(word));
      n:=0;
      while not eof(f) do
      begin
        blockRead(f,buffer,bufSize,bufIn);
        for i:=1 to bufIn do
        begin corpus.write(corr.w(buffer[i])^); gauge.add(2)
        end
      end;
      close(f); gauge.close;
end;

function countfq(offset: integer; var fq: matrix): boolean;
var start,stop,i,j,ci,cj: longint;
    gauge: aGauge;
    prompt: string[3];
begin countfq:=offset<>0;
      if offset=0 then exit;
      if offset<0 then begin start:=1-offset; stop:=args.corpus.Last end
      else begin start:=1; stop:=args.corpus.Last-offset end;
      if (start<1) or (stop<1) then exit;
      gauge.JobSize:=stop-start+1;
      str(offset,prompt);
      gauge.rewrite(wherey,wherex,'Counting at offset '+prompt);
      i:=start; j:=start+offset;
      for i:=start to stop do
      begin ci:=args.corpus.w(i)^; cj:=args.corpus.w(j)^;
            inc(fq.l(ci,cj)^);
            inc(j); gauge.add(1)
      end;
      gauge.close;
end;

procedure sort(var row,rowFq: vector);
var  i,j,k,m,n: integer; swap,yes: boolean;
     tmp: string; tmpFq: longint; tmpI: word;
begin  m:=1; n:=row.lastCol;
       while m<=n do m:=m+m; m:=(m-1) DIV 2;
       while m>0 do
       begin  for j:=1 TO n-m do
	 begin  i:=j; k:=i+m; swap:=true;
	   repeat if rowFq.l(i)^<rowFq.l(k)^ then
	     begin  tmpFq:=rowFq.l(i)^;
	        rowFq.l(i)^:=rowFq.l(k)^; rowFq.l(k)^:=tmpFq;
                tmpI:=row.w(i)^;
	        row.w(i)^:=row.w(k)^; row.w(k)^:=tmpI;
 	        i:=i-m; k:=i+m;
                  swap:=i>0;
           end else swap:=false
         until not swap
       end;
       m:=m DIV 2
     end;
end;


procedure writeFq(fn: string; offset: integer; var fq: matrix);
var ext,entry: string;
    fqij,sum,n: longint;
    i,j: word;
    f: text;
    col: byte;
    gauge: aGauge;
    row,rowfq: vector;
begin str(offset:0,ext);
      assign(f,fn+ext); rewrite(f);
      writeln(f,args.maxWords,' active words out of ',args.allWords);
      writeln(f,args.fnDic,' dictionary.');
      writeln(f,args.fnFqDic,' wordlist in order of decreasing frequencies.');
      if args.sortedFq then
      begin
        row.assign('w'); row.rewrite(fq.lastCol);
        rowFq.assign('l'); rowFq.rewrite(fq.lastCol);
      end;
      gauge.JobSize:=args.fqDic.Last;
      gauge.rewrite(wherey,wherex,'Saving to '+fn+ext+'...');
      with args do
      begin fqDic.seek(1);
            for i:=1 to fqDic.Last do
            begin n:=0; sum:=0;
                  for j:=1 to fqDic.Last do
                  begin fqij:=fq.l(i,j)^;
                        if fqij>0
                        then begin inc(n); inc(sum,fqij)
                        end
                  end;
                  fqDic.read(entry);
                  writeln(f,'#',i,' ',n,' ',sum,' of ',fqDic.frequency,' ',entry);
                  col:=0;

                  if args.sortedFq then
                  begin
                    for j:=1 to row.LastCol do row.w(j)^:=j;
                    for j:=1 to rowFq.LastCol do rowFq.l(j)^:=fq.l(i,j)^;
                    sort(row,rowFq);
                    j:=1;
                    while (j<=row.LastCol) and (rowFq.l(j)^>0) do
                    begin write(f,' ',rowFq.l(j)^,' x',row.w(j)^);
                        inc(col); inc(j);
                        if col mod 10=0 then
                        begin writeln(f); col:=0
                        end
                    end
                  end
                  else
                  begin for j:=1 to fq.lastCol do if fq.l(i,j)^>0 then
                        begin write(f,' ',fq.l(i,j)^,' x',j);
                           inc(col);
                           if col mod 10=0 then
                           begin writeln(f); col:=0
                           end
                        end
                  end;
                  if col mod 10<>0 then writeln(f);
                  gauge.add(1)
            end
      end;
      close(f); gauge.close;
      if args.sortedFq then
      begin row.close; rowFq.close
      end
end;


var  dic: dictionary;
     fq: matrix;
     corr: vector;
     offset: integer;
begin
      getArgs;
      getFn;
      readDic(dic);
      if dic.Last<args.maxWords then args.maxWords:=dic.last;
      readFqDic(args.fqDic);
      buildMatcher(args.fqDic,dic,corr);
      readCorpus(args.fqDic,corr,args.corpus);
      corr.close; dic.erase;
      fq.assign('lFrequencies');
      fq.rewrite(args.fqDic.Last,args.fqDic.Last);
      for offset:=args.left to args.right
      do
      if countfq(offset,fq)
      then
      begin
            writeFq(args.fnFq,offset,fq);
            fq.fillChar(0);
      end;
      fq.close;
      writeln; writeln
end.
