unit lg3; {$R-}
interface
type
     ptInteger=^integer;
     ptReal=^real;
     ptChar=^char;
     ptWord=^word;
     ptByte=^byte;
     ptLongint=^longint;
     ptBoolean=^boolean;
     ptString=^string;
     ptRecord=pointer;
     longArray=object name: string[40];
                      hidden: array[1..35] of byte;
                      procedure assign(st: string);
                      procedure rewrite(items: longint; itemSize: word);
                      procedure reset;
                      procedure seek(item: longint);
                      procedure append;
                      procedure read(var item);
                      procedure write(var item);
                      procedure seekAndWrite(it: longint; var item);
                      procedure seekAndRead(it: longint; var item);
                      procedure get(var item);
                      procedure put(var item);
                      procedure seekAndGet(it: longint; var item);
                      procedure seekAndPut(it: longint; var item);
                      procedure close;
                      procedure erase;
                      function fileSize: longint;
                      function last: longint;
                      function filePos: longint;
                      procedure fillChar(filler: byte);
                      function eof: boolean;
                      function i(it: longint): ptInteger;
                      function b(it: longint): ptByte;
                      function w(it: longint): ptWord;
                      function l(it: longint): ptLongint;
                      function r(it: longint): ptReal;
                      function t(it: longint): ptBoolean;
                      function c(it: longint): ptChar;
                      function s(it: longint): ptString;
                      function p(it: longint): ptRecord;
     end;
     stringPtr=^string;

    longintPtr=^longint;
    dictionary=object name: string[40];
                    index,corpus: longArray;
                    frequency: longint;
                    fqPtr: longintPtr;
                    entryPoint,exitPoint: array[char] of longint;
                    procedure Assign(st: string);
                    procedure Rewrite(items: longint);
                    procedure Reset;
                    procedure Seek(item: longint);
                    procedure Append;
                    procedure Find(st: string; var foundPos: longint);
                    procedure QuickSearch;
                    procedure QuickFind(st: string; var foundPos: longint);
                    procedure FindBetween(st: string; lo,hi: longint; var foundPos: longint);
                    procedure Read(var st: string);
                    procedure Write(st: string);
                    procedure Put(st: string);
                    procedure Get(var st: string);
                    procedure Add(st: string; fq: longint);
                    procedure SeekAndWrite(i: longint; st: string);
                    procedure SeekAndRead(i: longint; var st: string);
                    procedure SeekAndGet(i: longint; var st: string);
                    procedure SeekAndPut(i: longint; st: string);
                    procedure Close;
                    procedure Erase;
                    function  FileSize:longint;
                    function  Last: longint;
                    function  FilePos: longint;
                    function  Eof: boolean;
                    function  s(it: longint): string;
     end;
procedure memInsertVar(var a: longArray; var what);
procedure memMoveVar(var a: longArray; pos1,pos2,itemsToMove: longint);
procedure SetFq(var st: string; fq: longint);
procedure GetFq(var st:
 string; var fq: longint);


implementation uses crt;
const expectedWordLength=10;

type aRowPtr=^aRow;
     aDictionaryPtr=^dictionary;
     anIndex=array[0..16379] of aRowPtr;
     anIndexPtr=^anIndex;
     aRow= array[0..65519] of byte;

     memRec=object
       name: string[40];
       bytesPerRow,bytesInIndex,lastRow,recordsPerRow,
       bytesPerRecord,shift,mask: word;
       maxRecordsInArray,lastRecord,pos: longint;
       insertMode: boolean;
       rowPtrNo: anIndexPtr;
       dicPtr:   aDictionaryPtr;
     end;

procedure SaveDic(var d: dictionary; fn: string);
var f: text; c,cc: char; i: longint; st: string;
begin write('Save current state of dictionary? (y/n) ');
      repeat c:=upcase(readkey);
	     if keypressed then cc:=readkey
      until (c='Y') or (c='N');
      writeln;
      if c='Y' then
      begin assign(f,fn);
	    rewrite(f);
	    write('Saving to '+fn+'... ');
	    d.Seek(1);
	    for i:=1 to d.Last do
	    begin d.Read(st);
		  SetFq(st,d.frequency);
		  writeln(f,st)
	    end;
	    Close(f);
	    writeln(' Dictionary saved.')
      end;
end;

procedure SaveMem(var a: longArray; fn: string);
var f: file of byte; i: longint; j,n: word; c,cc: char;
    unknown: array[1..8196] of byte;
begin write('Save current state of array? (y/n) ');
      repeat c:=upcase(readkey);
	     if keypressed then cc:=readkey
      until (c='Y') or (c='N');
      writeln;
      if c='Y' then
      begin assign(f,fn);
	    rewrite(f);
	    write('Saving to '+fn+'... ');
	    a.Reset;
	    n:=memRec(a).bytesPerRecord;
	    for i:=0 to a.Last do
	    begin a.Read(unknown);
		  for j:=1 to n do write(f,unknown[j])
	    end;
	    Close(f);
	    writeln(' Array saved.')
      end;
end;

procedure Abort(var a: longArray; bytesNeeded: longint; msg: string);
begin with memRec(a) do
begin    writeln;
         write('Not enough space for '+msg+' of "'+name+'"');
         if dicPtr<>nil then
         writeln(' of dictionary "'+dicPtr^.name+'"')
         else writeln;
         writeln(bytesNeeded,' bytes needed, ',MaxAvail,' available');
	 if dicPtr<>nil then
	 begin SaveDic(dicPtr^,'ABORTED.DIC'); dicPtr^.Erase;
	 end
	 else
	 begin SaveMem(a,'ABORTED.MEM'); a.Erase
	 end;
         Halt(1);
end
end;

procedure SetFq(var st: string; fq: longint);
begin if length(st)>251 then st[0]:=#251;
      move(fq,st[length(st)+1],4); inc(st[0],4);
end;

procedure GetFq(var st: string; var fq: longint);
begin dec(st[0],4);
      move(st[length(st)+1],fq,4)
end;

procedure longArray.Assign(st: string);
var pos,n,lgth: byte;
begin name:=st;
end;

procedure longArray.Reset;
begin Seek(0)
end;

procedure longArray.Append;
begin Seek(FileSize)
end;

procedure longArray.Rewrite(items: longint; itemSize: word);
var it: word; expectedSize,n: longint;
begin
    system.FillChar(hidden,SizeOf(hidden),0);
    with memRec(self) do
begin
   bytesPerRecord:=itemSize;
   expectedSize:=items*bytesPerRecord;
   recordsPerRow:=65520 div bytesPerRecord;
   if recordsPerRow>items then recordsPerRow:=items;
   n:=32768; shift:=15;
   while (n>recordsPerRow) and (n>2) do begin n:=n div 2; dec(shift) end;
   mask:=(1 shl shift) -1;
   recordsPerRow:=n;
   bytesPerRow:=recordsPerRow * bytesPerRecord;
   lastRow:=items div recordsPerRow; (* first Row = 0 *)
   maxRecordsInArray:=longint(lastRow+1) * longint(recordsPerRow);
   lastRecord:=-1;
   bytesInIndex:=(lastRow+1)*sizeOf(pointer);
   GetMem(rowPtrNo,bytesInIndex);
   for it:=0 to lastRow do
   begin
         GetMem(rowPtrNo^[it],bytesPerRow);
         system.FillChar(rowPtrNo^[it]^,bytesPerRow,0)
   end;
end
end;

procedure longarray.fillChar(filler: byte);
var it: word;
begin with memRec(self) do
   for it:=0 to lastRow do
   begin
         GetMem(rowPtrNo^[it],bytesPerRow);
         system.FillChar(rowPtrNo^[it]^,bytesPerRow,filler)
   end;
end;
procedure MemExpand(var a: longArray; items: longint);
var newLastRow,bytesInNewIndex,i: word;
    newIndex_: anIndexPtr;
begin with memRec(a) do
begin
   newLastRow:=(items) div recordsPerRow;
   if newLastRow<=lastRow then exit;
   bytesInNewIndex:=(newLastRow+1)*sizeOf(pointer);
   if bytesInNewIndex>MaxAvail then Abort(a,bytesInNewIndex,' index ');
   GetMem(newIndex_,bytesInNewIndex);
   Move(rowPtrNo^,newIndex_^,bytesInIndex);
   FreeMem(rowPtrNo,bytesInIndex);
   rowPtrNo:=newIndex_;
   for i:=lastRow+1 to newLastRow do
   begin
         if bytesPerRow>MaxAvail then
         Abort(a,bytesPerRow,' data ');

         GetMem(rowPtrNo^[i],bytesPerRow);
         FillChar(rowPtrNo^[i]^,bytesPerRow,0);
   end;
   lastRow:=newLastRow;
   bytesInIndex:=bytesInNewIndex;
   maxRecordsInArray:=(lastRow+1)*recordsPerRow;
end;
end;

procedure memReadString(var a: longArray; var st: string);
var row,col,lgth: word;
    stPtr: stringPtr;
    str: string;
begin with memRec(a) do
begin
      row:= pos shr shift;
      col:=(pos and mask);
      stPtr:=@rowPtrNo^[row]^[col];
      lgth:=length(stPtr^)+1;
      {lgth:=rowPtrNo^[row]^[col];}
      Move(stPtr^,str,lgth); st:=str;
      { if directly Move(stPtr^,st,lgth) then st='Y' !!!}
      inc(pos,lgth);
end
end;

procedure memReadStringPtr(var a: longArray; var st: stringPtr);
var row,col: word;
begin with memRec(a) do
begin
      row:= pos shr shift;
      col:=(pos and mask);
      st:=addr(rowPtrNo^[row]^[col]);
end
end;

procedure MemWriteString(var a: longArray; st: string);
var row,col,lgth: word; ST2: string;
begin with memRec(a) do
begin lgth:=length(st)+1;
      pos:=lastRecord+1;
      row:= pos shr shift;
      col:=(pos and mask);
      if col+lgth>bytesPerRow-1
      then
      begin inc(row); col:=0;
            if row>lastRow then
            MemExpand(a,longint(row+1)*bytesPerRow);
      end;
      Move(st,rowPtrNo^[row]^[col],lgth);
      lastRecord:=longint(row)*bytesPerRow+col+lgth-1;
      pos:=lastRecord+1;
      Move(rowPtrNo^[row]^[col],st2,lgth);
end
end;


procedure longArray.Seek(item: longint);
begin with memRec(self) do
begin if (item<0) then Exit;
      if (item>maxRecordsInArray) then MemExpand(self,item);
      pos:=item;
end;
end;

procedure memMoveVar(var a: longArray; pos1,pos2,itemsToMove: longint);
var newlastRecord,newItemCapacity: longint;
    itemsFromSource,itemsIntoTarget: word;
    res, {Row of end of source }
    rss, {Row of start of source }
    css, {Col of start of source }
    ces, {Col of end of source }
    ret, {Row of end of target }
    cet  {Col of end of target }
    : word;
begin with MemRec(a) do
begin newlastRecord:=pos2+itemsToMove-1;
      if newLastRecord<lastRecord then newLastRecord:=lastRecord;
      newItemCapacity:=newlastRecord div recordsPerRow * recordsPerRow{-1};
      lastRecord:=newLastRecord;
      if newLastRecord>=maxRecordsInArray then
      begin MemExpand(a,newlastRecord);
      end;
      rss:=pos1 div recordsPerRow;
      css:= pos1 mod recordsPerRow;
      inc(pos1,itemsToMove-1); inc(pos2,itemsToMove-1);
      res:=pos1 div recordsPerRow;
      ret:=pos2 div recordsPerRow;
      ces:=pos1 mod recordsPerRow;
      cet:=pos2 mod recordsPerRow;
      repeat
             if rss=res then
             itemsFromSource:=itemsToMove
             else itemsFromSource:=ces+1;
             itemsIntoTarget:=cet+1;
             if itemsFromSource>itemsIntoTarget
             then itemsFromSource:=itemsIntoTarget;
              Move(rowPtrNo^[res]^[bytesPerRecord*(ces+1-itemsFromSource)],
                   rowPtrNo^[ret]^[bytesPerRecord*(cet+1-itemsFromSource)],
                  itemsFromSource*bytesPerRecord);
             dec(itemsToMove,itemsFromSource);
             dec(pos1,itemsFromSource);
             res:=pos1 div recordsPerRow;
             ces:=pos1 mod recordsPerRow;
             dec(pos2,itemsFromSource);
             ret:=pos2 div recordsPerRow;
             cet:=pos2 mod recordsPerRow;
      until itemsToMove=0;
end
end;


procedure memPutVar(var a: longArray; var what);
var row,col: word;
    dummy: byte absolute what;
begin with memRec(a) do
begin
      if pos+1>maxRecordsInArray then BEGIN
        MemExpand(a,pos);
      END;
      if pos>lastRecord then lastRecord:=pos;
      row:= pos shr shift;
      col:=(pos and mask) * bytesPerRecord;
      Move(dummy,rowPtrNo^[row]^[col],bytesPerRecord);
end;
end;

procedure memInsertVar(var a: longArray; var what);
var row,col: word;
    dummy: byte absolute what;
begin with memRec(a) do
begin if pos<=lastRecord
      then memMoveVar(a,pos,pos+1,lastRecord-pos+1)
      else
      begin if pos+1>maxRecordsInArray then MemExpand(a,pos);
            if pos>lastRecord then lastRecord:=pos;
      end;
      row:= pos shr shift;
      col:=(pos and mask) * bytesPerRecord;
      Move(dummy,rowPtrNo^[row]^[col],bytesPerRecord);
end;
end;


procedure longArray.Read(var item);
var row,col: word; dummy: byte absolute item;
begin with MemRec(self) do
begin
    if pos>lastRecord then system.FillChar(dummy,bytesPerRecord,0)
    else
    begin
      row:= pos shr shift;
      col:=(pos and mask) * bytesPerRecord;
      Move(rowPtrNo^[row]^[col],dummy,bytesPerRecord);
      inc(pos)
    end
end
end;


procedure longArray.Get(var item);
var row,col: word; dummy: byte absolute item;
begin with MemRec(self) do
begin
    if pos>lastRecord then system.FillChar(dummy,bytesPerRecord,0)
    else
    begin
      row:= pos shr shift;
      col:=(pos and mask) * bytesPerRecord;
      Move(rowPtrNo^[row]^[col],dummy,bytesPerRecord);
    end
end
end;


procedure longArray.Write(var item);
var anon: byte absolute item;
begin with memRec(self) do
begin
       if insertMode then MemInsertVar(self,anon)
       else MemPutVar(self,anon);
       inc(pos)
end;
end;

procedure longArray.Put(var item);
var anon: byte absolute item;
begin with memRec(self) do
begin if insertMode then MemInsertVar(self,anon)
      else MemPutVar(self,anon);
end;
end;

function longArray.i(it: longint): ptInteger;
var row,col: word;
begin with memRec(self) do
begin pos:=it;
      if it+1>maxRecordsInArray then BEGIN
        MemExpand(self,pos);
      END;
      if pos>lastRecord then lastRecord:=pos;
      row:= pos shr shift;
      col:=(pos and mask) * bytesPerRecord;
      i:=ptInteger(@rowPtrNo^[row]^[col]);
end;
end;

function longArray.b(it: longint): ptByte;
var row,col: word;
begin with memRec(self) do
begin pos:=it;
      if it+1>maxRecordsInArray then BEGIN
        MemExpand(self,pos);
      END;
      if pos>lastRecord then lastRecord:=pos;
      row:= pos shr shift;
      col:=(pos and mask) * bytesPerRecord;
      b:=ptByte(@rowPtrNo^[row]^[col]);
end;
end;

function longArray.w(it: longint): ptWord;
var row,col: word;
begin with memRec(self) do
begin pos:=it;
      if it+1>maxRecordsInArray then BEGIN
        MemExpand(self,pos);
      END;
      if pos>lastRecord then lastRecord:=pos;
      row:= pos shr shift;
      col:=(pos and mask) * bytesPerRecord;
      w:=ptWord(@rowPtrNo^[row]^[col]);
end;
end;


function longArray.l(it: longint): ptLongint;
var row,col: word;
begin with memRec(self) do
begin pos:=it;
      if it+1>maxRecordsInArray then BEGIN
        MemExpand(self,pos);
      END;
      if pos>lastRecord then lastRecord:=pos;
      row:= pos shr shift;
      col:=(pos and mask) * bytesPerRecord;
      l:=ptLongint(@rowPtrNo^[row]^[col]);
end;
end;


function longArray.r(it: longint): ptReal;
var row,col: word;
begin with memRec(self) do
begin pos:=it;
      if it+1>maxRecordsInArray then BEGIN
        MemExpand(self,pos);
      END;
      if pos>lastRecord then lastRecord:=pos;
      row:= pos shr shift;
      col:=(pos and mask) * bytesPerRecord;
      r:=ptReal(@rowPtrNo^[row]^[col]);
end;
end;


function longArray.c(it: longint): ptChar;
var row,col: word;
begin with memRec(self) do
begin pos:=it;
      if it+1>maxRecordsInArray then BEGIN
        MemExpand(self,pos);
      END;
      if pos>lastRecord then lastRecord:=pos;
      row:= pos shr shift;
      col:=(pos and mask) * bytesPerRecord;
      c:=ptChar(@rowPtrNo^[row]^[col]);
end;
end;

function longArray.t(it: longint): ptBoolean;
var row,col: word;
begin with memRec(self) do
begin pos:=it;
      if it+1>maxRecordsInArray then BEGIN
        MemExpand(self,pos);
      END;
      if pos>lastRecord then lastRecord:=pos;
      row:= pos shr shift;
      col:=(pos and mask) * bytesPerRecord;
      t:=ptBoolean(@rowPtrNo^[row]^[col]);
end;
end;

function longArray.s(it: longint): ptString;
var row,col: word;
begin with memRec(self) do
begin pos:=it;
      if it+1>maxRecordsInArray then BEGIN
        MemExpand(self,pos);
      END;
      if pos>lastRecord then lastRecord:=pos;
      row:= pos shr shift;
      col:=(pos and mask) * bytesPerRecord;
      s:=ptString(@rowPtrNo^[row]^[col]); (* COULD BE DODGY *)
end;
end;

function longArray.p(it: longint): ptRecord;
var row,col: word;
begin with memRec(self) do
begin pos:=it;
      if it+1>maxRecordsInArray then BEGIN
        MemExpand(self,pos);
      END;
      if pos>lastRecord then lastRecord:=pos;
      row:= pos shr shift;
      col:=(pos and mask) * bytesPerRecord;
      p:=@rowPtrNo^[row]^[col];
end;
end;

procedure longArray.SeekAndWrite(it: longint; var item);
var anon: byte absolute item;
begin with memRec(self) do
begin pos:=it;
      if insertMode then MemInsertVar(self,anon)
      else MemPutVar(self,anon);
      inc(pos);
end;
end;

procedure longArray.SeekAndPut(it: longint; var item);
var anon: byte absolute item;
begin with memRec(self) do
begin pos:=it;
      if insertMode then MemInsertVar(self,anon)
      else MemPutVar(self,anon);
end;
end;


procedure longArray.SeekAndRead(it: longint; var item);
var row,col: word; dummy: byte absolute item;
begin with MemRec(self) do
begin pos:=it;
    if pos>lastRecord then system.FillChar(dummy,bytesPerRecord,0)
    else
    begin
      row:= pos shr shift;
      col:=(pos and mask) * bytesPerRecord;
      Move(rowPtrNo^[row]^[col],dummy,bytesPerRecord);
      inc(pos)
    end
end
end;

procedure longArray.SeekAndGet(it: longint; var item);
var row,col: word; dummy: byte absolute item;
begin with MemRec(self) do
begin pos:=it;
    if pos>lastRecord then system.FillChar(dummy,bytesPerRecord,0)
    else
    begin
      row:= pos shr shift;
      col:=(pos and mask) * bytesPerRecord;
      Move(rowPtrNo^[row]^[col],dummy,bytesPerRecord);
    end
end
end;


procedure MemSetInsertMode(var a: longArray; onOff: boolean);
begin memRec(a).insertMode:=onOff
end;


procedure longArray.Close;
begin
end;

procedure longArray.Erase;
var it: word;
begin with MemRec(self) do
begin for it:=lastRow downto 0 do
      FreeMem(rowPtrNo^[it],bytesPerRow);
      FreeMem(rowPtrNo,bytesInIndex);
end
end;


function longArray.Last: longint;
begin Last:=memRec(self).lastRecord
end;

function  longArray.FileSize:longint;
begin FileSize:=memRec(self).lastRecord+1
end;

function  longArray.Eof: boolean;
begin with memRec(self) do Eof:=pos>lastRecord;
end;

function  longArray.FilePos: longint;
begin FilePos:=memRec(self).pos
end;


procedure dictionary.Assign(st: string);
begin name:=st;
      index.Assign('index'); corpus.Assign('corpus');
end;

procedure dictionary.Reset;
begin Seek(0)
end;

procedure dictionary.Append;
begin Seek(FileSize)
end;

procedure dictionary.Rewrite(items: longint);
var null: string;
begin
      index.Rewrite(items,SizeOf(pointer));
      memSetInsertMode(index,true);
      items:=items*(expectedWordLength+5);
      if items<256 then items:=256;
      corpus.Rewrite(items,sizeOf(char));
      memRec(index).dicPtr:=@self;
      memRec(corpus).dicPtr:=@self;
      null:='';
      Put(null);
end;

procedure dictionary.QuickSearch;
var i: longint; entry: string; ch,ch2: char;
begin Seek(1); ch:=#0;
      fillChar(entryPoint,sizeOf(entryPoint),0);
      fillChar(exitPoint,sizeOf(exitPoint),0);
      for i:=1 to Last do
      begin read(entry); ch2:=entry[1];
        if ch2<>ch then
        begin entryPoint[ch2]:=i;
              exitPoint[ch]:=i-1;
              ch:=ch2
        end
      end;
      exitPoint[ch2]:=Last
end;

procedure dictionary.Close;
begin
end;


procedure dictionary.Erase;
begin corpus.Erase; index.Erase
end;

procedure dictionary.Seek(item: longint);
begin index.Seek(item)
end;

procedure dictionary.Find(st: string; var foundPos: longint);
var lo,mid,hi,posInCorpus,oldPos: longint; found: boolean;
    tmpPtr: stringPtr; tmp: string;
begin found:=false; lo:=0; hi:=index.FileSize-1;
      oldPos:=memRec(corpus).pos;
      while (lo<=hi) and not found do
      begin mid:=(lo+hi) div 2;
         index.SeekAndRead(mid,posInCorpus);
         corpus.Seek(posInCorpus);
         memReadStringPtr(corpus,tmpPtr);
         tmp:=tmpPtr^;
         GetFq(tmp,frequency);
         if st>tmp then lo:=mid+1 else
         if st<tmp then hi:=mid-1 else
         if st=tmp then found:=true;
      end;
      if found then
      begin FoundPos:=mid;
            fqPtr:=longintPtr(longint(tmpPtr)+length(tmp)+1);
      end
      else foundPos:=-lo;
      memRec(corpus).pos:=oldPos;
end;

procedure dictionary.QuickFind(st: string; var foundPos: longint);
var ch: char;
begin ch:=st[1]; FindBetween(st,entryPoint[ch],exitPoint[ch],foundPos);
end;
procedure dictionary.FindBetween(st: string; lo,hi: longint; var foundPos: longint);
var mid,posInCorpus,oldPos: longint; found: boolean;
    tmpPtr: stringPtr; tmp: string;
begin found:=false;
      if lo>hi then
      begin mid:=lo; lo:=hi; hi:=mid
      end;
      mid:=index.FileSize-1;
      if lo>mid then lo:=mid;
      if hi>mid then hi:=mid;
      oldPos:=memRec(corpus).pos;
      while (lo<=hi) and not found do
      begin mid:=(lo+hi) div 2;
         index.SeekAndRead(mid,posInCorpus);
         corpus.Seek(posInCorpus);
         memReadStringPtr(corpus,tmpPtr);
         tmp:=tmpPtr^;
         GetFq(tmp,frequency);
         if st>tmp then lo:=mid+1 else
         if st<tmp then hi:=mid-1 else
         if st=tmp then found:=true;
      end;
      if found then
      begin FoundPos:=mid;
            fqPtr:=longintPtr(longint(tmpPtr)+length(tmp)+1);
      end
      else foundPos:=-lo;
      memRec(corpus).pos:=oldPos;
end;


procedure dictionary.Read(var st: string);
var posInCorpus: longint;
begin index.Read(posInCorpus);
      corpus.Seek(posInCorpus);
      memReadString(corpus,st);
      GetFq(st,frequency);
end;

procedure dictionary.SeekAndGet(i: longint; var st: string);
var posInCorpus: longint;
begin index.SeekAndGet(i,posInCorpus);
      corpus.Seek(posInCorpus);
      memReadString(corpus,st);
      GetFq(st,frequency);
end;

function dictionary.s(it: longint): string;
var posInCorpus: longint; st: string;
begin index.SeekAndGet(it,posInCorpus);
      corpus.Seek(posInCorpus);
      memReadString(corpus,st);
      GetFq(st,frequency);
      s:=st;
end;

procedure dictionary.Get(var st: string);
var posInCorpus,oldCorpusPos: longint; TMP: string;
begin 
      index.Get(posInCorpus);
      (* oldCorpusPos:=memRec(corpus).pos; *)
      corpus.Seek(posInCorpus);
      memReadString(corpus,st);
      GetFq(st,frequency);
      (* memRec(corpus).pos:=oldCorpusPos; *)
end;

procedure dictionary.Put(st: string);
var indexPos: longint;
begin
      SetFq(st,1);
      memWriteString(corpus,st);
      indexPos:=corpus.FileSize-(length(st)+1);
      index.Write(indexPos);
end;

procedure dictionary.SeekAndRead(i: longint; var st: string);
var posInCorpus: longint;
begin index.SeekAndRead(i,posInCorpus);
      corpus.Seek(posInCorpus);
      memReadString(corpus,st);
      GetFq(st,frequency);
end;


procedure dictionary.SeekAndWrite(i: longint; st: string);
var corpusPos: longint;
begin SetFq(st,1);
      memWriteString(corpus,st);
      corpusPos:=corpus.FilePos-(length(st)+1);
      index.SeekAndWrite(i,corpusPos);
end;



procedure dictionary.SeekAndPut(i: longint; st: string);
var corpusPos: longint;
begin SetFq(st,1);
      memWriteString(corpus,st);
      corpusPos:=corpus.FilePos-(length(st)+1);
      index.SeekAndPut(i,corpusPos);
end;



procedure dictionary.Write(st: string);
var i: longint;
begin Find(st,i);
      if i<0 then
      SeekAndWrite(-i,st)
      else inc(fqPtr^);
end;

procedure dictionary.Add(st: string; fq: longint);
var i: longint; corpusPos: longint;
begin Find(st,i);
      if i<0 then
      begin SetFq(st,fq); i:=-i;
            memWriteString(corpus,st);
            corpusPos:=corpus.FilePos-(length(st)+1);
            index.SeekAndWrite(i,corpusPos);
      end
      else
      begin inc(fqPtr^,fq);
            frequency:=fqPtr^
      end
end;


function dictionary.Last: longint;
begin Last:=index.Last;
end;


function  dictionary.FileSize;
begin FileSize:=index.FileSize;
end;

function  dictionary.FilePos: longint;
begin FilePos:=index.FilePos
end;

function  dictionary.Eof: boolean;
begin Eof:=index.Eof
end;


end.
